searchData={"items":[{"type":"module","title":"Prql","doc":"PRQL compiler for Elixir, powered by Rust's prqlc.","ref":"Prql.html"},{"type":"function","title":"Prql.compile/2","doc":"Compiles a PRQL query to SQL.","ref":"Prql.html#compile/2"},{"type":"function","title":"Options - Prql.compile/2","doc":"- `:format` - Whether to format the SQL output (default: `false`)\n- `:target` - The SQL dialect to target (optional, no default)\n- `:signature_comment` - Whether to include the PRQL signature comment (default: `false`)\n- `:color` - Whether to enable color in the output (default: `false`)\n- `:display` - Display options for the output (`:plain` or `:ansi_color`, default: `:plain`)","ref":"Prql.html#compile/2-options"},{"type":"function","title":"Examples - Prql.compile/2","doc":"iex> Prql.compile(\"from employees | select {name, age}\")\n    {:ok, \"SELECT name, age FROM employees\"}\n\n    iex> Prql.compile(\"from employees | select {name, age}\", target: :postgres)\n    {:ok, \"SELECT name, age FROM employees\"}\n\nReturns `{:ok, sql_string}` on success, or `{:error, reason}` on failure.","ref":"Prql.html#compile/2-examples"},{"type":"function","title":"Prql.compile!/2","doc":"Same as `compile/2` but raises an exception if compilation fails.","ref":"Prql.html#compile!/2"},{"type":"function","title":"Options - Prql.compile!/2","doc":"See `compile/2` for available options.","ref":"Prql.html#compile!/2-options"},{"type":"function","title":"Examples - Prql.compile!/2","doc":"iex> Prql.compile!(\"from employees | select {name, age}\")\n    \"SELECT name, age FROM employees\"\n\n    iex> Prql.compile!(\"from employees | select {name, age}\", target: :postgres)\n    \"SELECT name, age FROM employees\"\n\n    iex> Prql.compile!(\"invalid prql\")\n    ** (RuntimeError) PRQL compilation failed: ...","ref":"Prql.html#compile!/2-examples"},{"type":"type","title":"Prql.dialect/0","doc":"","ref":"Prql.html#t:dialect/0"},{"type":"type","title":"Prql.display_option/0","doc":"","ref":"Prql.html#t:display_option/0"},{"type":"type","title":"Prql.option/0","doc":"","ref":"Prql.html#t:option/0"},{"type":"type","title":"Prql.options/0","doc":"","ref":"Prql.html#t:options/0"},{"type":"module","title":"Prql.Options","doc":"","ref":"Prql.Options.html"},{"type":"type","title":"Prql.Options.dialect/0","doc":"","ref":"Prql.Options.html#t:dialect/0"},{"type":"type","title":"Prql.Options.display_option/0","doc":"","ref":"Prql.Options.html#t:display_option/0"},{"type":"function","title":"Prql.Options.normalize/1","doc":"Normalizes and validates compilation options.\n\nReturns `{:ok, normalized_options}` on success, or `{:error, reason}` on failure.","ref":"Prql.Options.html#normalize/1"},{"type":"type","title":"Prql.Options.option/0","doc":"","ref":"Prql.Options.html#t:option/0"},{"type":"type","title":"Prql.Options.options/0","doc":"","ref":"Prql.Options.html#t:options/0"},{"type":"extras","title":"Prql","doc":"# Prql\n\nPRQL (Pipelined Relational Query Language) compiler for Elixir, powered by Rust's `prqlc`.","ref":"readme.html"},{"type":"extras","title":"Features - Prql","doc":"- Compile PRQL queries to SQL\n- Support for multiple SQL dialects\n- Configurable output formatting\n- Clean error messages with helpful hints","ref":"readme.html#features"},{"type":"extras","title":"Installation - Prql","doc":"Add `prql` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:prql, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Prql","doc":"```elixir\n# Basic usage\n{:ok, sql} = Prql.compile(\"from employees | select {name, age}\")\n#=> {:ok, \"SELECT name, age FROM employees\"}\n\n# With options\n{:ok, sql} = Prql.compile(\"from employees | select {name, age}\", \n  format: true, \n  target: :postgres\n)\n\n# Error handling\n{:error, reason} = Prql.compile(\"invalid prql\")\n#=> {:error, \"PRQL compilation error (unexpected token)\"}\n```","ref":"readme.html#usage"},{"type":"extras","title":"Options - Prql","doc":"- `:format` - Whether to format the SQL output (default: `false`)\n- `:target` - The SQL dialect to target (e.g., `:postgres`, `:mysql`, `:snowflake`)\n- `:signature_comment` - Whether to include the PRQL signature comment (default: `false`)\n- `:color` - Whether to enable color in the output (default: `false`)\n- `:display` - Display options (`:plain` or `:ansi_color`)","ref":"readme.html#options"},{"type":"extras","title":"Error Handling - Prql","doc":"PRQL compilation errors include helpful error messages with hints. For example:\n\n```elixir\n{:error, reason} = Prql.compile(\"from employees | select {name,}\")\n#=> {:error, \"Unexpected token (Expected an identifier after .)\"}\n```","ref":"readme.html#error-handling"},{"type":"extras","title":"Development - Prql","doc":"","ref":"readme.html#development"},{"type":"extras","title":"Building the NIF - Prql","doc":"The NIF is built automatically when compiling the Elixir code. For development, you can build it manually:\n\n```bash\ncd native/prql_native\ncargo build\n```","ref":"readme.html#building-the-nif"},{"type":"extras","title":"Running Tests - Prql","doc":"```bash\nmix test\n```","ref":"readme.html#running-tests"},{"type":"extras","title":"License - Prql","doc":"This project is licensed under the Apache License 2.0 - see the [LICENSE](LICENSE) file for details.","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}